<!DOCTYPE html>
<html lang='en'>
<head>
  <title>RSpec results</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Expires" content="-1" />
  <meta http-equiv="Pragma" content="no-cache" />
  <style type="text/css">
  body {
    margin: 0;
    padding: 0;
    background: #fff;
    font-size: 80%;
  }
  </style>
  <script type="text/javascript">
    // <![CDATA[

function addClass(element_id, classname) {
  document.getElementById(element_id).className += (" " + classname);
}

function removeClass(element_id, classname) {
  var elem = document.getElementById(element_id);
  var classlist = elem.className.replace(classname,'');
  elem.className = classlist;
}

function moveProgressBar(percentDone) {
  document.getElementById("rspec-header").style.width = percentDone +"%";
}

function makeRed(element_id) {
  removeClass(element_id, 'passed');
  removeClass(element_id, 'not_implemented');
  addClass(element_id,'failed');
}

function makeYellow(element_id) {
  var elem = document.getElementById(element_id);
  if (elem.className.indexOf("failed") == -1) {  // class doesn't includes failed
    if (elem.className.indexOf("not_implemented") == -1) { // class doesn't include not_implemented
      removeClass(element_id, 'passed');
      addClass(element_id,'not_implemented');
    }
  }
}

function apply_filters() {
  var passed_filter = document.getElementById('passed_checkbox').checked;
  var failed_filter = document.getElementById('failed_checkbox').checked;
  var pending_filter = document.getElementById('pending_checkbox').checked;

  assign_display_style("example passed", passed_filter);
  assign_display_style("example failed", failed_filter);
  assign_display_style("example not_implemented", pending_filter);

  assign_display_style_for_group("example_group passed", passed_filter);
  assign_display_style_for_group("example_group not_implemented", pending_filter, pending_filter || passed_filter);
  assign_display_style_for_group("example_group failed", failed_filter, failed_filter || pending_filter || passed_filter);
}

function get_display_style(display_flag) {
  var style_mode = 'none';
  if (display_flag == true) {
    style_mode = 'block';
  }
  return style_mode;
}

function assign_display_style(classname, display_flag) {
  var style_mode = get_display_style(display_flag);
  var elems = document.getElementsByClassName(classname)
  for (var i=0; i<elems.length;i++) {
    elems[i].style.display = style_mode;
  }
}

function assign_display_style_for_group(classname, display_flag, subgroup_flag) {
  var display_style_mode = get_display_style(display_flag);
  var subgroup_style_mode = get_display_style(subgroup_flag);
  var elems = document.getElementsByClassName(classname)
  for (var i=0; i<elems.length;i++) {
    var style_mode = display_style_mode;
    if ((display_flag != subgroup_flag) && (elems[i].getElementsByTagName('dt')[0].innerHTML.indexOf(", ") != -1)) {
      elems[i].style.display = subgroup_style_mode;
    } else {
      elems[i].style.display = display_style_mode;
    }
  }
}

    // ]]>
  </script>
  <style type="text/css">
#rspec-header {
  background: #65C400; color: #fff; height: 4em;
}

.rspec-report h1 {
  margin: 0px 10px 0px 10px;
  padding: 10px;
  font-family: "Lucida Grande", Helvetica, sans-serif;
  font-size: 1.8em;
  position: absolute;
}

#label {
  float:left;
}

#display-filters {
  float:left;
  padding: 28px 0 0 40%;
  font-family: "Lucida Grande", Helvetica, sans-serif;
}

#summary {
  float:right;
  padding: 5px 10px;
  font-family: "Lucida Grande", Helvetica, sans-serif;
  text-align: right;
}

#summary p {
  margin: 0 0 0 2px;
}

#summary #totals {
  font-size: 1.2em;
}

.example_group {
  margin: 0 10px 5px;
  background: #fff;
}

dl {
  margin: 0; padding: 0 0 5px;
  font: normal 11px "Lucida Grande", Helvetica, sans-serif;
}

dt {
  padding: 3px;
  background: #65C400;
  color: #fff;
  font-weight: bold;
}

dd {
  margin: 5px 0 5px 5px;
  padding: 3px 3px 3px 18px;
}

dd .duration {
  padding-left: 5px;
  text-align: right;
  right: 0px;
  float:right;
}

dd.example.passed {
  border-left: 5px solid #65C400;
  border-bottom: 1px solid #65C400;
  background: #DBFFB4; color: #3D7700;
}

dd.example.not_implemented {
  border-left: 5px solid #FAF834;
  border-bottom: 1px solid #FAF834;
  background: #FCFB98; color: #131313;
}

dd.example.pending_fixed {
  border-left: 5px solid #0000C2;
  border-bottom: 1px solid #0000C2;
  color: #0000C2; background: #D3FBFF;
}

dd.example.failed {
  border-left: 5px solid #C20000;
  border-bottom: 1px solid #C20000;
  color: #C20000; background: #FFFBD3;
}


dt.not_implemented {
  color: #000000; background: #FAF834;
}

dt.pending_fixed {
  color: #FFFFFF; background: #C40D0D;
}

dt.failed {
  color: #FFFFFF; background: #C40D0D;
}


#rspec-header.not_implemented {
  color: #000000; background: #FAF834;
}

#rspec-header.pending_fixed {
  color: #FFFFFF; background: #C40D0D;
}

#rspec-header.failed {
  color: #FFFFFF; background: #C40D0D;
}


.backtrace {
  color: #000;
  font-size: 12px;
}

a {
  color: #BE5C00;
}

/* Ruby code, style similar to vibrant ink */
.ruby {
  font-size: 12px;
  font-family: monospace;
  color: white;
  background-color: black;
  padding: 0.1em 0 0.2em 0;
}

.ruby .keyword { color: #FF6600; }
.ruby .constant { color: #339999; }
.ruby .attribute { color: white; }
.ruby .global { color: white; }
.ruby .module { color: white; }
.ruby .class { color: white; }
.ruby .string { color: #66FF00; }
.ruby .ident { color: white; }
.ruby .method { color: #FFCC00; }
.ruby .number { color: white; }
.ruby .char { color: white; }
.ruby .comment { color: #9933CC; }
.ruby .symbol { color: white; }
.ruby .regex { color: #44B4CC; }
.ruby .punct { color: white; }
.ruby .escape { color: white; }
.ruby .interp { color: white; }
.ruby .expr { color: white; }

.ruby .offending { background-color: gray; }
.ruby .linenum {
  width: 75px;
  padding: 0.1em 1em 0.2em 0;
  color: #000000;
  background-color: #FFFBD3;
}

  </style>
</head>
<body>
<div class="rspec-report">

<div id="rspec-header">
  <div id="label">
    <h1>RSpec Code Examples</h1>
  </div>

  <div id="display-filters">
    <input id="passed_checkbox"  name="passed_checkbox"  type="checkbox" checked="checked" onchange="apply_filters()" value="1" /> <label for="passed_checkbox">Passed</label>
    <input id="failed_checkbox"  name="failed_checkbox"  type="checkbox" checked="checked" onchange="apply_filters()" value="2" /> <label for="failed_checkbox">Failed</label>
    <input id="pending_checkbox" name="pending_checkbox" type="checkbox" checked="checked" onchange="apply_filters()" value="3" /> <label for="pending_checkbox">Pending</label>
  </div>

  <div id="summary">
    <p id="totals">&#160;</p>
    <p id="duration">&#160;</p>
  </div>
</div>


<div class="results">
<div id="div_group_1" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_1" class="passed">true</dt>
    <script type="text/javascript">moveProgressBar('9.0');</script>
    <dd class="example passed"><span class="passed_spec_name">should equal true</span><span class='duration'>0.00115s</span></dd>
  </dl>
</div>
<div id="div_group_2" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_2" class="passed">User inspec</dt>
    <script type="text/javascript">moveProgressBar('18.1');</script>
    <dd class="example passed"><span class="passed_spec_name">should exist</span><span class='duration'>0.01754s</span></dd>
  </dl>
</div>
<div id="div_group_3" class="example_group passed">
  <dl style="margin-left: 15px;">
  <dt id="example_group_3" class="passed">uid</dt>
    <script type="text/javascript">moveProgressBar('27.2');</script>
    <dd class="example passed"><span class="passed_spec_name">should eq 1000</span><span class='duration'>0.00225s</span></dd>
  </dl>
</div>
<div id="div_group_4" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_4" class="passed">System Package git</dt>
    <script type="text/javascript">moveProgressBar('36.3');</script>
    <dd class="example passed"><span class="passed_spec_name">should be installed</span><span class='duration'>0.15783s</span></dd>
  </dl>
</div>
<div id="div_group_5" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_5" class="passed">System Package openssh-client</dt>
    <script type="text/javascript">moveProgressBar('45.4');</script>
    <dd class="example passed"><span class="passed_spec_name">should be installed</span><span class='duration'>0.15554s</span></dd>
  </dl>
</div>
<div id="div_group_6" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_6" class="passed">gem package inspec</dt>
    <script type="text/javascript">moveProgressBar('54.5');</script>
    <dd class="example passed"><span class="passed_spec_name">should be installed</span><span class='duration'>0.00028s</span></dd>
  </dl>
</div>
<div id="div_group_7" class="example_group passed">
  <dl style="margin-left: 15px;">
  <dt id="example_group_7" class="passed">versions.count</dt>
    <script type="text/javascript">moveProgressBar('63.6');</script>
    <dd class="example passed"><span class="passed_spec_name">should eq 1</span><span class='duration'>0.00018s</span></dd>
  </dl>
</div>
<div id="div_group_8" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_8" class="passed">gem package inspec-bin</dt>
    <script type="text/javascript">moveProgressBar('72.7');</script>
    <dd class="example passed"><span class="passed_spec_name">should be installed</span><span class='duration'>0.00014s</span></dd>
  </dl>
</div>
<div id="div_group_9" class="example_group passed">
  <dl style="margin-left: 15px;">
  <dt id="example_group_9" class="passed">versions.count</dt>
    <script type="text/javascript">moveProgressBar('81.8');</script>
    <dd class="example passed"><span class="passed_spec_name">should eq 1</span><span class='duration'>0.00010s</span></dd>
  </dl>
</div>
<div id="div_group_10" class="example_group passed">
  <dl style="margin-left: 0px;">
  <dt id="example_group_10" class="passed">gem package rubocop</dt>
    <script type="text/javascript">makeRed('rspec-header');</script>
    <script type="text/javascript">makeRed('div_group_10');</script>
    <script type="text/javascript">makeRed('example_group_10');</script>
    <script type="text/javascript">moveProgressBar('90.9');</script>
    <dd class="example failed">
      <span class="failed_spec_name">should be installed</span>
      <span class="duration">0.01629s</span>
      <div class="failure" id="failure_1">
        <div class="message"><pre>  Failure/Error: [0m[1;34;4mDEFAULT_FAILURE_NOTIFIER[0m = lambda { |failure, _opts| raise failure }
    expected that `gem package rubocop` is installed
  # localtests/controls/demo.rb:27:in `block (4 levels) in load_with_context&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner_rspec.rb:75:in `run&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:159:in `run_tests&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:130:in `run&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/cli.rb:287:in `exec&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/command.rb:27:in `run&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/invocation.rb:126:in `invoke_command&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor.rb:387:in `dispatch&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/base.rb:466:in `start&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/base_cli.rb:33:in `start&#39;</pre></div>
        <div class="backtrace"><pre>localtests/controls/demo.rb:27:in `block (4 levels) in load_with_context&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner_rspec.rb:75:in `run&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:159:in `run_tests&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:130:in `run&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/cli.rb:287:in `exec&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/command.rb:27:in `run&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/invocation.rb:126:in `invoke_command&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor.rb:387:in `dispatch&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/base.rb:466:in `start&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/base_cli.rb:33:in `start&#39;</pre></div>
    <pre class="ruby"><code><span class="linenum">25</span>  [ <span class="string"><span class="delimiter">'</span><span class="content">inspec</span><span class="delimiter">'</span></span>, <span class="string"><span class="delimiter">'</span><span class="content">inspec-bin</span><span class="delimiter">'</span></span>, <span class="string"><span class="delimiter">'</span><span class="content">rubocop</span><span class="delimiter">'</span></span>].each { |gem|
<span class="linenum">26</span>    <span class="keyword">describe</span> gem(gem) <span class="keyword">do</span>
<span class="offending"><span class="linenum">27</span>      <span class="keyword">it</span> { should be_installed }</span>
<span class="linenum">28</span>      its(<span class="string"><span class="delimiter">'</span><span class="content">versions.count</span><span class="delimiter">'</span></span>) { should eq <span class="integer">1</span> }
<span class="linenum">29</span>    <span class="keyword">end</span></code></pre>
      </div>
    </dd>
  </dl>
</div>
<div id="div_group_11" class="example_group passed">
  <dl style="margin-left: 15px;">
  <dt id="example_group_11" class="passed">versions.count</dt>
    <script type="text/javascript">makeRed('div_group_11');</script>
    <script type="text/javascript">makeRed('example_group_11');</script>
    <script type="text/javascript">moveProgressBar('100.0');</script>
    <dd class="example failed">
      <span class="failed_spec_name">example at localtests/controls/demo.rb:28</span>
      <span class="duration">0.00020s</span>
      <div class="failure" id="failure_2">
        <div class="message"><pre>  Failure/Error: [0minner_subject.send(attr)

  NoMethodError:
    undefined method `count&#39; for nil:NilClass
  # localtests/controls/demo.rb:28:in `block (4 levels) in load_with_context&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner_rspec.rb:75:in `run&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:159:in `run_tests&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:130:in `run&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/cli.rb:287:in `exec&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/command.rb:27:in `run&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/invocation.rb:126:in `invoke_command&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor.rb:387:in `dispatch&#39;
  # /usr/local/bundle/gems/thor-0.20.3/lib/thor/base.rb:466:in `start&#39;
  # /usr/local/bundle/gems/inspec-4.18.39/lib/inspec/base_cli.rb:33:in `start&#39;</pre></div>
        <div class="backtrace"><pre>localtests/controls/demo.rb:28:in `block (4 levels) in load_with_context&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner_rspec.rb:75:in `run&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:159:in `run_tests&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/runner.rb:130:in `run&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/cli.rb:287:in `exec&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/command.rb:27:in `run&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/invocation.rb:126:in `invoke_command&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor.rb:387:in `dispatch&#39;
/usr/local/bundle/gems/thor-0.20.3/lib/thor/base.rb:466:in `start&#39;
/usr/local/bundle/gems/inspec-4.18.39/lib/inspec/base_cli.rb:33:in `start&#39;</pre></div>
    <pre class="ruby"><code><span class="linenum">26</span>    <span class="keyword">describe</span> gem(gem) <span class="keyword">do</span>
<span class="linenum">27</span>      <span class="keyword">it</span> { should be_installed }
<span class="offending"><span class="linenum">28</span>      its(<span class="string"><span class="delimiter">'</span><span class="content">versions.count</span><span class="delimiter">'</span></span>) { should eq <span class="integer">1</span> }</span>
<span class="linenum">29</span>    <span class="keyword">end</span>
<span class="linenum">30</span>  }</code></pre>
      </div>
    </dd>
  </dl>
</div>
<script type="text/javascript">document.getElementById('duration').innerHTML = "Finished in <strong>0.41688 seconds</strong>";</script>
<script type="text/javascript">document.getElementById('totals').innerHTML = "11 examples, 2 failures";</script>
</div>
</div>
</body>
</html>
